## libtracefs 1.8.0

=== meson_options.txt ===
# SPDX-License-Identifier: LGPL-2.1
#
# Copyright (c) 2023 Daniel Wagner, SUSE LLC

option('htmldir', type : 'string', value : 'share/doc/libtracefs-doc',
       description : 'directory for HTML documentation')
option('asciidoctor', type : 'boolean', value: false,
       description : 'use asciidoctor instead of asciidoc')
option('docbook-xls-172', type : 'boolean', value : false,
       description : 'enable docbook XLS 172 workaround')
option('asciidoc-no-roff', type : 'boolean', value : false,
       description : 'enable no roff workaround')
option('man-bold-literal', type : 'boolean', value : false,
       description : 'enable bold literals')
option('docbook-suppress-sp', type : 'boolean', value : false,
       description : 'docbook suppress sp')
option('doc', type : 'boolean', value: true,
       description : 'produce documentation')
option('samples', type : 'boolean', value: true,
       description : 'build samples')

=== samples/Makefile ===
# SPDX-License-Identifier: LGPL-2.1

#
# The samples are pulled out of the examples used in the man pages
# that are located in the Documentation directory.
#

include $(src)/scripts/utils.mk

EXAMPLES :=
EXAMPLES += dynevents
EXAMPLES += kprobes
EXAMPLES += eprobes
EXAMPLES += uprobes
EXAMPLES += synth
EXAMPLES += error
EXAMPLES += filter
EXAMPLES += function-filter
EXAMPLES += hist
EXAMPLES += hist-cont
EXAMPLES += tracer
EXAMPLES += stream
EXAMPLES += instances-affinity
EXAMPLES += cpu
EXAMPLES += guest
EXAMPLES += cpu-buf
EXAMPLES += instances-stat
EXAMPLES += instances-subbuf
EXAMPLES += cpu-map

TARGETS :=
TARGETS += sqlhist
TARGETS += $(EXAMPLES)

sdir := $(obj)/bin

TARGETS := $(patsubst %,$(sdir)/%,$(TARGETS))

all: $(TARGETS)

$(bdir)/sqlhist.c: $(src)/Documentation/libtracefs-sql.txt
	$(call extract_example,$<,$@)

$(bdir)/%.c: ../Documentation/libtracefs-%.txt
	$(call extract_example,$<,$@)

$(sdir):
	@mkdir -p $(sdir)

sqlhist: $(sdir)/sqlhist

$(TARGETS): $(sdir)

# sqlhist is unique and stands on its own
$(sdir)/sqlhist: $(bdir)/sqlhist.c $(LIBTRACEFS_STATIC)
	$(call do_sample_build,$@,$<)

$(sdir)/%: $(bdir)/%.o
	$(call do_sample_build,$@,$<)

$(EXAMPLES): $(patsubst %,$(sdir)/%,$(TARGETS))

## The intermediate files get removed by Make.
## To examine the .c files created by one of the man pages,
## uncomment the below, and replace the XX with the exec example
## name, and the file will not be discarded by make.
#
# $(bdir)/XX.o: $(bdir)/XX.c
#	$(CC) -g -Wall $(CFLAGS) -c -o $@ $^ -I../include/ $(LIBTRACEEVENT_INCLUDES)
$(bdir)/kprobes.o: $(bdir)/kprobes.c
	$(CC) -g -Wall $(CFLAGS) -c -o $@ $^ -I../include/ $(LIBTRACEEVENT_INCLUDES)

$(bdir)/%.o: $(bdir)/%.c
	$(call do_sample_obj,$@,$^)

$(bdir)/XX.o: $(bdir)/hist.c
	$(CC) -g -Wall $(CFLAGS) -c -o $@ $^ -I../include/ $(LIBTRACEEVENT_INCLUDES)

clean:
	$(Q)$(call do_clean,$(sdir)/* $(bdir)/sqlhist.c $(bdir)/sqlhist.o)

.PHONY: sqlhist

=== debian/changelog ===
libtracefs (1.8.0-1ubuntu1) noble; urgency=medium

  * Remove "patches/" from .gitignore
  * Bump libtraceevent-dev Build-Depends to >= 1:1.8.0
  * Only use online CPUs during tests
    - d/p/testsuite-use-only-online-cpus.patch
  * Return an error from trace-utest if one of the tests failed:
    - d/p/testsuite-return-error-when-tests-failed.patch
  * Build and run the upstream testsuite (as root) during build
  * Run the upstream test suite during autopkgtest (requires root and VM)
    (LP: #2055309)
    - Build autopkgtest testsuite against installed library
    - Ignore CI-incompatible test failures in CI
    - Add d/tests/autopkgtest-specific.patch to support required changes

 -- Adrien Nader <adrien.nader@canonical.com>  Tue, 16 Apr 2024 22:25:06 +0200

libtracefs (1.8.0-1) unstable; urgency=medium

  * New upstream version 1.8.0
    - Update symbols.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 16 Jan 2024 22:17:46 +0000

=== debian/control ===
Source: libtracefs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends:
 debhelper-compat (= 13), libcunit1-dev, libtraceevent-dev (>= 1:1.8.0),
 pkg-config, asciidoc, xmlto, source-highlight, flex, bison
Standards-Version: 4.6.2
Section: libs
Homepage: https://git.kernel.org/pub/scm/libs/libtrace/libtracefs.git
Vcs-Browser: https://salsa.debian.org/sudip/libtracefs
Vcs-Git: https://salsa.debian.org/sudip/libtracefs.git
Rules-Requires-Root:

Package: libtracefs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Suggests: libtracefs-doc
Depends: libtracefs1 (= ${binary:Version}), ${misc:Depends}
Description: API to access the kernel tracefs directory (development files)
 The libtracefs library provides APIs to access kernel tracefs file system.
 .
 This package is needed to compile programs against libtracefs1.

Package: libtracefs1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: API to access the kernel tracefs directory (shared library)
 The libtracefs library provides APIs to access kernel tracefs file system.
 .
 This package contains the shared library.

Package: libtracefs-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: API to access the kernel tracefs directory (documentation)
 The libtracefs library provides APIs to access kernel tracefs file system.
 .
 This package contains the documentation of libtracefs.

## libtracefs 1.8.1

=== Makefile ===
# SPDX-License-Identifier: LGPL-2.1
# libtracefs version
TFS_VERSION = 1
TFS_PATCHLEVEL = 8
TFS_EXTRAVERSION = 1
TRACEFS_VERSION = $(TFS_VERSION).$(TFS_PATCHLEVEL).$(TFS_EXTRAVERSION)

export TFS_VERSION
export TFS_PATCHLEVEL
export TFS_EXTRAVERSION
export TRACEFS_VERSION

# Note, samples and utests need 1.8.1
LIBTRACEEVENT_MIN_VERSION = 1.8

# taken from trace-cmd
MAKEFLAGS += --no-print-directory

# Makefiles suck: This macro sets a default value of $(2) for the
# variable named by $(1), unless the variable has been set by
# environment or command line. This is necessary for CC and AR
# because make sets default values, so the simpler ?= approach
# won't work as expected.
define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
$(call allow-override,CC,$(CROSS_COMPILE)gcc)
$(call allow-override,AR,$(CROSS_COMPILE)ar)
$(call allow-override,PKG_CONFIG,pkg-config)
$(call allow-override,LD_SO_CONF_PATH,/etc/ld.so.conf.d/)
$(call allow-override,LDCONFIG,ldconfig)

EXT = -std=gnu99
INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

LP64 := $(shell echo __LP64__ | ${CC} ${CFLAGS} -E -x c - | tail -n 1)
ifeq ($(LP64), 1)
  libdir_relative_temp = lib64
else
  libdir_relative_temp = lib
endif

libdir_relative ?= $(libdir_relative_temp)
prefix ?= /usr/local
man_dir ?= $(prefix)/share/man
man_dir_SQ = '$(subst ','\'',$(man_dir))'
libdir ?= $(prefix)/$(libdir_relative)
libdir_SQ = '$(subst ','\'',$(libdir))'
includedir_relative ?= include/tracefs
includedir ?= $(prefix)/$(includedir_relative)
includedir_SQ = '$(subst ','\'',$(includedir))'
pkgconfig_dir ?= $(word 1,$(shell $(PKG_CONFIG) 		\
			--variable pc_path pkg-config | tr ":" " "))

TEST_LIBTRACEEVENT = $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEEVENT_MIN_VERSION) libtraceevent > /dev/null 2>&1 && echo y")

ifeq ("$(TEST_LIBTRACEEVENT)", "y")
LIBTRACEEVENT_INCLUDES = $(shell sh -c "$(PKG_CONFIG) --cflags libtraceevent")
LIBTRACEEVENT_LIBS = $(shell sh -c "$(PKG_CONFIG) --libs libtraceevent")
else
 ifneq ($(MAKECMDGOALS),clean)
   $(error libtraceevent.so minimum version of $(LIBTRACEEVENT_MIN_VERSION) not installed)
 endif
endif

ifndef NO_VSOCK
VSOCK_DEFINED := $(shell if (echo "$(pound)include <linux/vm_sockets.h>" | $(CC) -E - >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
else
VSOCK_DEFINED := 0
endif

ifndef NO_PERF
PERF_DEFINED := $(shell if (echo "$(pound)include <linux/perf_event.h>" | $(CC) -E - >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
else
PREF_DEFINED := 0
endif

etcdir ?= /etc
etcdir_SQ = '$(subst ','\'',$(etcdir))'

export man_dir man_dir_SQ html_install html_install_SQ INSTALL
export img_install img_install_SQ
export DESTDIR DESTDIR_SQ
export VSOCK_DEFINED PERF_DEFINED

pound := \#

HELP_DIR = -DHELP_DIR=$(html_install)
HELP_DIR_SQ = '$(subst ','\'',$(HELP_DIR))'
#' emacs highlighting gets confused by the above escaped quote.

BASH_COMPLETE_DIR ?= $(etcdir)/bash_completion.d

# copy a bit from Linux kbuild

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

SILENT := $(if $(findstring s,$(filter-out --%,$(MAKEFLAGS))),1)

# $(call test-build, snippet, ret) -> ret if snippet compiles
#                                  -> empty otherwise
test-build = $(if $(shell sh -c 'echo "$(1)" | \
	$(CC) -o /dev/null -c -x c - > /dev/null 2>&1 && echo y'), $2)

ifeq ("$(origin O)", "command line")

  saved-output := $(O)
  BUILD_OUTPUT := $(shell cd $(O) && /bin/pwd)
  $(if $(BUILD_OUTPUT),, \
    $(error output directory "$(saved-output)" does not exist))

else
  BUILD_OUTPUT = $(CURDIR)
endif

srctree		:= $(if $(BUILD_SRC),$(BUILD_SRC),$(CURDIR))
objtree		:= $(BUILD_OUTPUT)
src		:= $(srctree)
obj		:= $(objtree)
bdir		:= $(obj)/lib

export prefix src obj bdir

LIBTRACEFS_STATIC = $(bdir)/libtracefs.a
LIBTRACEFS_SHARED = $(bdir)/libtracefs.so.$(TRACEFS_VERSION)

LIBTRACEFS_SHARED_SO = $(bdir)/libtracefs.so
LIBTRACEFS_SHARED_VERSION = $(bdir)/libtracefs.so.$(TFS_VERSION)

PKG_CONFIG_SOURCE_FILE = libtracefs.pc
PKG_CONFIG_FILE := $(addprefix $(obj)/,$(PKG_CONFIG_SOURCE_FILE))

LPTHREAD ?= -lpthread
LIBS = $(LIBTRACEEVENT_LIBS) $(LPTHREAD)

export LIBS
export LIBTRACEFS_STATIC LIBTRACEFS_SHARED
export LIBTRACEEVENT_LIBS LIBTRACEEVENT_INCLUDES
export LIBTRACEFS_SHARED_SO LIBTRACEFS_SHARED_VERSION

export Q SILENT VERBOSE EXT

# Include the utils
include scripts/utils.mk

INCLUDES = -I$(src)/include
INCLUDES += -I$(src)/include/tracefs

include $(src)/scripts/features.mk

# Set compile option CFLAGS if not set elsewhere
ifdef EXTRA_CFLAGS
  CFLAGS ?= $(EXTRA_CFLAGS)
else
  CFLAGS ?= -g -Wall
endif

CFLAGS ?= -g -Wall
CPPFLAGS ?=
LDFLAGS ?=

CUNIT_INSTALLED := $(shell if (printf "$(pound)include <CUnit/Basic.h>\n void main(){CU_initialize_registry();}" | $(CC) -x c - -lcunit -o /dev/null >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
export CUNIT_INSTALLED

# Append required CFLAGS
override CFLAGS += -D_GNU_SOURCE $(LIBTRACEEVENT_INCLUDES) $(INCLUDES)

# Make sure 32 bit stat() works on large file systems
override CFLAGS += -D_FILE_OFFSET_BITS=64

export CFLAGS
export INCLUDES

all: all_cmd

LIB_TARGET  = libtracefs.a libtracefs.so.$(TRACEFS_VERSION)
LIB_INSTALL = libtracefs.a libtracefs.so*
LIB_INSTALL := $(addprefix $(bdir)/,$(LIB_INSTALL))

TARGETS = libtracefs.so libtracefs.a

all_cmd: $(TARGETS) $(PKG_CONFIG_FILE)

libtracefs.a: $(bdir) $(LIBTRACEFS_STATIC)
libtracefs.so: $(bdir) $(LIBTRACEFS_SHARED)

libs: libtracefs.a libtracefs.so

VALGRIND = $(shell which valgrind)
UTEST_DIR = utest
UTEST_BINARY = trace-utest

test: force $(LIBTRACEFS_STATIC)
ifneq ($(CUNIT_INSTALLED),1)
	$(error CUnit framework not installed, cannot build unit tests))
endif
	$(Q)$(call descend,$(src)/$(UTEST_DIR),$@)

test_mem: test
ifeq (, $(VALGRIND))
	$(error "No valgrind in $(PATH), cannot run memory test")
endif
ifneq ($(shell id -u), 0)
	$(error "The unit test should be run as root, as it reuqires full access to tracefs")
endif
	CK_FORK=no LD_LIBRARY_PATH=$(bdir) $(VALGRIND) \
		--show-leak-kinds=all --leak-resolution=high \
		--leak-check=full --show-possibly-lost=yes \
		--track-origins=yes -s \
		$(src)/$(UTEST_DIR)/$(UTEST_BINARY)

define find_tag_files
	find $(src) -name '\.pc' -prune -o -name '*\.[ch]' -print -o -name '*\.[ch]pp' \
		! -name '\.#' -print
endef

define do_make_pkgconfig_file
	cp -f ${PKG_CONFIG_SOURCE_FILE}.template ${PKG_CONFIG_FILE};	\
	sed -i "s|INSTALL_PREFIX|${1}|g" ${PKG_CONFIG_FILE}; 		\
	sed -i "s|LIB_VERSION|${TRACEFS_VERSION}|g" ${PKG_CONFIG_FILE}; \
	sed -i "s|LIB_DIR|${libdir_relative}|g" ${PKG_CONFIG_FILE}; \
	sed -i "s|HEADER_DIR|$(includedir_relative)|g" ${PKG_CONFIG_FILE}; \
	sed -i "s|LIBTRACEEVENT_MIN|$(LIBTRACEEVENT_MIN_VERSION)|g" ${PKG_CONFIG_FILE};
endef

BUILD_PREFIX := $(BUILD_OUTPUT)/build_prefix

VERSION_FILE = tfs_version.h

$(BUILD_PREFIX): force
	$(Q)$(call build_prefix,$(prefix))

$(PKG_CONFIG_FILE) : ${PKG_CONFIG_SOURCE_FILE}.template $(BUILD_PREFIX) $(VERSION_FILE)
	$(Q) $(call do_make_pkgconfig_file,$(prefix))

VIM_TAGS = $(obj)/tags
EMACS_TAGS = $(obj)/TAGS
CSCOPE_TAGS = $(obj)/cscope

$(VIM_TAGS): force
	$(RM) $@
	$(call find_tag_files) | (cd $(obj) && xargs ctags --extra=+f --c-kinds=+px)

$(EMACS_TAGS): force
	$(RM) $@
	$(call find_tag_files) | (cd $(obj) && xargs etags)

$(CSCOPE_TAGS): force
	$(RM) $(obj)/cscope*
	$(call find_tag_files) | xargs cscope -b -q

tags: $(VIM_TAGS)
TAGS: $(EMACS_TAGS)
cscope: $(CSCOPE_TAGS)

ifeq ("$(DESTDIR)", "")
# If DESTDIR is not defined, then test if after installing the library
# and running ldconfig, if the library is visible by ld.so.
# If not, add the path to /etc/ld.so.conf.d/trace.conf and run ldconfig again.
define install_ld_config
	if $(LDCONFIG); then \
		if ! grep -q "^$(libdir)$$" $(LD_SO_CONF_PATH)/* ; then \
			$(CC) -o $(objtree)/test $(srctree)/test.c -I $(includedir_SQ) \
				-L $(libdir_SQ) -ltracefs &> /dev/null; \
			if ! $(objtree)/test &> /dev/null; then \
				$(call print_install, trace.conf, $(LD_SO_CONF_PATH)) \
				echo $(libdir_SQ) >> $(LD_SO_CONF_PATH)/trace.conf; \
				$(LDCONFIG); \
			fi; \
			$(RM) $(objtree)/test; \
		fi; \
	fi
endef
else
# If installing to a location for another machine or package, do not bother
# with running ldconfig.
define install_ld_config
endef
endif # DESTDIR = ""

install_libs: libs install_pkgconfig
	$(Q)$(call do_install,$(LIBTRACEFS_SHARED),$(libdir_SQ)); \
		cp -fpR $(LIB_INSTALL) $(DESTDIR)$(libdir_SQ)
	$(Q)$(call do_install,$(src)/include/tracefs.h,$(includedir_SQ),644)
	$(Q)$(call install_ld_config)

install: install_libs

install_pkgconfig: $(PKG_CONFIG_FILE)
	$(Q)$(call , $(PKG_CONFIG_FILE)) \
		$(call do_install_pkgconfig_file,$(prefix))

doc: check_doc
	$(Q)$(call descend,$(src)/Documentation,all)

doc_clean:
	$(Q)$(call descend,$(src)/Documentation,clean)

install_doc:
	$(Q)$(call descend,$(src)/Documentation,install)

check_doc: force
	$(Q)$(src)/check-manpages.sh $(src)/Documentation

define build_uninstall_script
	$(Q)mkdir $(BUILD_OUTPUT)/tmp_build
	$(Q)$(MAKE) -C $(src) DESTDIR=$(BUILD_OUTPUT)/tmp_build/ O=$(BUILD_OUTPUT) $1 > /dev/null
	$(Q)find $(BUILD_OUTPUT)/tmp_build ! -type d -printf "%P\n" > $(BUILD_OUTPUT)/build_$2
	$(Q)$(RM) -rf $(BUILD_OUTPUT)/tmp_build
endef

build_uninstall: $(BUILD_PREFIX)
	$(call build_uninstall_script,install,uninstall)

$(BUILD_OUTPUT)/build_uninstall: build_uninstall

define uninstall_file
	if [ -f $(DESTDIR)/$1 -o -h $(DESTDIR)/$1 ]; then \
		$(call print_uninstall,$(DESTDIR)/$1)$(RM) $(DESTDIR)/$1; \
	fi;
endef

uninstall: $(BUILD_OUTPUT)/build_uninstall
	@$(foreach file,$(shell cat $(BUILD_OUTPUT)/build_uninstall),$(call uninstall_file,$(file)))

PHONY += force
force:

# Declare the contents of the .PHONY variable as phony.  We keep that
# information in a variable so we can use it in if_changed and friends.
.PHONY: $(PHONY)

DEFAULT_TARGET = $(LIBTRACEFS_STATIC)

OBJS =
OBJS += tracefs-utils.o
OBJS += tracefs-instance.o
OBJS += tracefs-events.o

OBJS := $(OBJS:%.o=$(bdir)/%.o)

all: $(DEFAULT_TARGET)

$(bdir):
	@mkdir -p $(bdir)

VERSION = $(TFS_VERSION)
PATCHLEVEL = $(TFS_PATCHLEVEL)
EXTRAVERSION = $(TFS_EXTRAVERSION)

define make_version.h
  (echo '/* This file is automatically generated. Do not modify. */';		\
   echo \#define VERSION_CODE $(shell						\
   expr $(VERSION) \* 256 + $(PATCHLEVEL));					\
   echo '#define EXTRAVERSION ' $(EXTRAVERSION);				\
   echo '#define VERSION_STRING "'$(VERSION).$(PATCHLEVEL).$(EXTRAVERSION)'"';	\
  ) > $1
endef

define update_version.h
  ($(call make_version.h, $@.tmp);		\
    if [ -r $@ ] && cmp -s $@ $@.tmp; then	\
      rm -f $@.tmp;				\
    else					\
      echo '  UPDATE             $@';		\
      mv -f $@.tmp $@;				\
    fi);
endef

$(VERSION_FILE): force
	$(Q)$(call update_version.h)

$(LIBTRACEFS_STATIC): force
	$(Q)$(call descend,$(src)/src,$@)

$(bdir)/libtracefs.so.$(TRACEFS_VERSION): force
	$(Q)$(call descend,$(src)/src,libtracefs.so)

samples/sqlhist: libtracefs.a
	$(Q)$(call descend,$(src)/samples,sqlhist)

sqlhist: samples/sqlhist

samples: libtracefs.a force
	$(Q)$(call descend,$(src)/samples,all)

clean: clean_meson
	$(Q)$(call descend_clean,utest)
	$(Q)$(call descend_clean,src)
	$(Q)$(call descend_clean,samples)
	$(Q)$(call do_clean, \
	  $(TARGETS) $(bdir)/*.a $(bdir)/*.so $(bdir)/*.so.* $(bdir)/*.o $(bdir)/.*.d \
	  $(PKG_CONFIG_FILE) \
	  $(VERSION_FILE) \
	  $(BUILD_PREFIX))

meson:
	$(MAKE) -f Makefile.meson

meson_install:
	$(MAKE) -f Makefile.meson install

meson_docs:
	$(MAKE) -f Makefile.meson docs

PHONY += clean_meson
clean_meson:
	$(Q)$(MAKE) -f Makefile.meson $@

.PHONY: clean

=== src/Makefile ===
# SPDX-License-Identifier: LGPL-2.1

include $(src)/scripts/utils.mk

OBJS =
OBJS += tracefs-utils.o
OBJS += tracefs-instance.o
OBJS += tracefs-events.o
OBJS += tracefs-tools.o
OBJS += tracefs-marker.o
OBJS += tracefs-kprobes.o
OBJS += tracefs-hist.o
OBJS += tracefs-stats.o
OBJS += tracefs-filter.o
OBJS += tracefs-dynevents.o
OBJS += tracefs-eprobes.o
OBJS += tracefs-uprobes.o
OBJS += tracefs-record.o
OBJS += tracefs-mmap.o
ifeq ($(VSOCK_DEFINED), 1)
OBJS += tracefs-vsock.o
endif
ifeq ($(PERF_DEFINED), 1)
OBJS += tracefs-perf.o
endif

# Order matters for the the three below
OBJS += sqlhist-lex.o
OBJS += sqlhist.tab.o
OBJS += tracefs-sqlhist.o

OBJS := $(OBJS:%.o=$(bdir)/%.o)

$(LIBTRACEFS_STATIC): $(OBJS)
	$(Q)$(call do_build_static_lib)

$(LIBTRACEFS_SHARED): $(OBJS)
	$(Q)$(call do_compile_shared_library,$(notdir $(LIBTRACEFS_SHARED_VERSION)))

$(LIBTRACEFS_SHARED_VERSION): $(LIBTRACEFS_SHARED)
	@ln -sf $(<F) $@

$(LIBTRACEFS_SHARED_SO): $(LIBTRACEFS_SHARED_VERSION)
	@ln -sf $(<F) $@

libtracefs.so: $(LIBTRACEFS_SHARED_SO)

# bison will create both sqlhist.tab.c and sqlhist.tab.h
sqlhist.tab.h:
sqlhist.tab.c: sqlhist.y sqlhist.tab.h
	bison --debug -v --report-file=bison.report -d -o $@ $<

sqlhist-lex.c: sqlhist.l sqlhist.tab.c
	flex -o $@ $<

$(bdir)/%.o: %.c
	$(Q)$(call do_fpic_compile)

tracefs-sqlhist.o: sqlhist.tab.h

$(OBJS): | $(bdir)

clean:
	$(Q)$(call do_clean,$(OBJS) .*.d)

-include .*.d

$(bdir)/tracefs-sqlhist.o tracefs-sqlhist.o: sqlhist.tab.h

.PHONY: $(LIBTRACEFS_SHARED_SO) $(LIBTRACEFS_STATIC)

=== debian/changelog ===
libtracefs (1.8.1-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2112036). Remaining changes:
    - Bump libtraceevent-dev Build-Depends to >= 1:1.8.0
    - Return an error from trace-utest if one of the tests failed:
      + d/p/testsuite-return-error-when-tests-failed.patch
    - Only use online CPUs during tests
      + d/p/testsuite-use-only-online-cpus.patch
    - Build and run the upstream testsuite (as root) during build
    - Run the upstream test suite during autopkgtest (requires root and VM)
      (LP #2055309)
      + Build autopkgtest testsuite against installed library
      + Ignore CI-incompatible test failures in CI
      + Add d/tests/autopkgtest-specific.patch to support required changes
    - debian/.gitignore: un-ignore patches/ as done in upstream

 -- Nick Rosbrook <enr0n@ubuntu.com>  Thu, 05 Jun 2025 16:43:09 -0400

libtracefs (1.8.1-1) unstable; urgency=medium

  * New upstream version 1.8.1
  * d/libtracefs1.symbols: remove MISSING symbols.
  * d/control: Depend on pkgconf instead of pkg-config.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 27 Jul 2024 19:50:01 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends:
  debhelper-compat (= 13), libcunit1-dev, libtraceevent-dev (>= 1:1.8.0),
- pkg-config, asciidoc, xmlto, source-highlight, flex, bison
+ pkgconf, asciidoc, xmlto, source-highlight, flex, bison
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://git.kernel.org/pub/scm/libs/libtrace/libtracefs.git

## libtracefs 1.8.2

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # libtracefs version
 TFS_VERSION = 1
 TFS_PATCHLEVEL = 8
-TFS_EXTRAVERSION = 1
+TFS_EXTRAVERSION = 2
 TRACEFS_VERSION = $(TFS_VERSION).$(TFS_PATCHLEVEL).$(TFS_EXTRAVERSION)
 
 export TFS_VERSION
@@ -55,6 +55,8 @@
 prefix ?= /usr/local
 man_dir ?= $(prefix)/share/man
 man_dir_SQ = '$(subst ','\'',$(man_dir))'
+completion_dir ?= $(prefix)/share/bash-completion/completions
+completion_dir_SQ = '$(subst ','\'',$(completion_dir))'
 libdir ?= $(prefix)/$(libdir_relative)
 libdir_SQ = '$(subst ','\'',$(libdir))'
 includedir_relative ?= include/tracefs
@@ -86,9 +88,6 @@
 PREF_DEFINED := 0
 endif
 
-etcdir ?= /etc
-etcdir_SQ = '$(subst ','\'',$(etcdir))'
-
 export man_dir man_dir_SQ html_install html_install_SQ INSTALL
 export img_install img_install_SQ
 export DESTDIR DESTDIR_SQ
@@ -99,8 +98,6 @@
 HELP_DIR = -DHELP_DIR=$(html_install)
 HELP_DIR_SQ = '$(subst ','\'',$(HELP_DIR))'
 #' emacs highlighting gets confused by the above escaped quote.
-
-BASH_COMPLETE_DIR ?= $(etcdir)/bash_completion.d
 
 # copy a bit from Linux kbuild
 
@@ -300,7 +297,10 @@
 	$(Q)$(call do_install,$(src)/include/tracefs.h,$(includedir_SQ),644)
 	$(Q)$(call install_ld_config)
 
-install: install_libs
+install_bash_completion: force
+	$(Q)$(call do_install_data,$(src)/src/tracefs_sql.bash,$(completion_dir))
+
+install: install_libs install_bash_completion
 
 install_pkgconfig: $(PKG_CONFIG_FILE)
 	$(Q)$(call , $(PKG_CONFIG_FILE)) \
@@ -399,6 +399,9 @@
 
 samples: libtracefs.a force
 	$(Q)$(call descend,$(src)/samples,all)
+
+sqlhist_remake:
+	$(Q)$(call descend,$(src)/src,sqlhist_remake)
 
 clean: clean_meson
 	$(Q)$(call descend_clean,utest)
@@ -411,17 +414,3 @@
 	  $(BUILD_PREFIX))
 
 meson:
-	$(MAKE) -f Makefile.meson
-
-meson_install:
-	$(MAKE) -f Makefile.meson install
-
-meson_docs:
-	$(MAKE) -f Makefile.meson docs
-
-PHONY += clean_meson
-clean_meson:
-	$(Q)$(MAKE) -f Makefile.meson $@
-
-.PHONY: clean
-

=== src/Makefile ===
--- 
+++ 
@@ -46,17 +46,19 @@
 libtracefs.so: $(LIBTRACEFS_SHARED_SO)
 
 # bison will create both sqlhist.tab.c and sqlhist.tab.h
-sqlhist.tab.h:
-sqlhist.tab.c: sqlhist.y sqlhist.tab.h
-	bison --debug -v --report-file=bison.report -d -o $@ $<
+sqlhist.tab_gen.h:
+sqlhist.tab_gen.c: sqlhist.y sqlhist.tab.h
+	bison --debug -v --report-file=bison.report -d -o $(subst _gen,,$@) $<
 
-sqlhist-lex.c: sqlhist.l sqlhist.tab.c
-	flex -o $@ $<
+sqlhist-lex_gen.c: sqlhist.l sqlhist.tab.c
+	flex -o $(subst _gen,,$@) $<
 
 $(bdir)/%.o: %.c
 	$(Q)$(call do_fpic_compile)
 
 tracefs-sqlhist.o: sqlhist.tab.h
+
+sqlhist_remake: sqlhist.tab_gen.c sqlhist-lex_gen.c
 
 $(OBJS): | $(bdir)
 
@@ -67,4 +69,4 @@
 
 $(bdir)/tracefs-sqlhist.o tracefs-sqlhist.o: sqlhist.tab.h
 
-.PHONY: $(LIBTRACEFS_SHARED_SO) $(LIBTRACEFS_STATIC)
+.PHONY: $(LIBTRACEFS_SHARED_SO) $(LIBTRACEFS_STATIC) sqlhist.tab_gen.c sqlhist-lex_gen.c

=== debian/changelog ===
libtracefs (1.8.2-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable (LP: #2130159). Remaining changes:
    - Return an error from trace-utest if one of the tests failed:
      + d/p/testsuite-return-error-when-tests-failed.patch
    - Only use online CPUs during tests
      + d/p/testsuite-use-only-online-cpus.patch
    - Build and run the upstream testsuite (as root) during build
    - Run the upstream test suite during autopkgtest (requires root and VM)
      (LP #2055309)
      + Build autopkgtest testsuite against installed library
      + Ignore CI-incompatible test failures in CI
      + Add d/tests/autopkgtest-specific.patch to support required changes
    - debian/.gitignore: un-ignore patches/ as done in upstream
  * Dropped, no longer needed:
    - Bump libtraceevent-dev Build-Depends to >= 1:1.8.0
  * New changes:
    - Drop hunk from d/p/testsuite-use-only-online-cpus.patch that removes the
      uprobes test without explanation

 -- Nick Rosbrook <enr0n@ubuntu.com>  Tue, 04 Nov 2025 10:36:43 -0500

libtracefs (1.8.2-1) unstable; urgency=medium

  * New upstream version 1.8.2
  * Update Standards-Version to 4.7.2.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 11 Aug 2025 06:52:30 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends:
- debhelper-compat (= 13), libcunit1-dev, libtraceevent-dev (>= 1:1.8.0),
+ debhelper-compat (= 13), libcunit1-dev, libtraceevent-dev (>= 1:1.3.0),
  pkgconf, asciidoc, xmlto, source-highlight, flex, bison
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://git.kernel.org/pub/scm/libs/libtrace/libtracefs.git
 Vcs-Browser: https://salsa.debian.org/sudip/libtracefs

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
        VERBOSE=1
endif

export DEB_GAIN_ROOT_CMD='sudo -nE --'

PREFIX=/usr
build_flags = prefix=$(PREFIX) libdir_relative=lib/$(DEB_HOST_MULTIARCH) pkgconfig_dir=$(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/pkgconfig V=$(VERBOSE)

%:
	dh $@ --no-parallel

override_dh_auto_build:
	dh_auto_build -- all doc $(build_flags)

override_dh_auto_install:
	dh_auto_install -- install_doc $(build_flags)

execute_after_dh_auto_test:
	# Up to 3 attempts as one test fails randomly (~3% failure rate)
	./utest/trace-utest || ./utest/trace-utest || ./utest/trace-utest

=== debian/tests/control ===
Tests: build-examples.sh
Depends: @, @builddeps@
Restrictions: needs-root, superficial

# We require some patching to get a testsuite that passes in CI but remains useful.
# Most of the change is in d/tests/autopkgtest-specific.patch. We also need to
# include code from src/tracefs-utils.c which is meant for the testsuite but is
# not in the .so; luckiy we can simply copy part of that file in the testsuite;
# unfortunately this introduces compilation warnings which we have to be sent
# to stdout to avoid a spurious test failure.
Test-Command: patch -p1 < debian/tests/autopkgtest-specific.patch && head -n 161 < src/tracefs-utils.c >> utest/tracefs-utest.c && make LIBTRACEFS_STATIC= test 2>&1 && ./utest/trace-utest
Features: test-name=trace-utest
Depends: @, @builddeps@
Restrictions: needs-root, isolation-machine

# We allow-stderr here because the test uses valgrind which always outputs
# something to stderr. There are memory leak reports too but it's not realistic
# to fix/suppress them; valgrind is useful to catch more serious errors too so
# I'm including it.
# The tests are the same as the ones for trace-utest, except they run under
# valgrind. I don't know whether the randomly-failing test aforementioned will
# be an issue here.
Test-Command: make LIBTRACEFS_STATIC= test_mem
Features: test-name=trace-utest-valgrind
Depends: @, @builddeps@, valgrind
Restrictions: needs-root, isolation-machine, allow-stderr

## libtracefs 1.8.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # libtracefs version
 TFS_VERSION = 1
 TFS_PATCHLEVEL = 8
-TFS_EXTRAVERSION = 2
+TFS_EXTRAVERSION = 3
 TRACEFS_VERSION = $(TFS_VERSION).$(TFS_PATCHLEVEL).$(TFS_EXTRAVERSION)
 
 export TFS_VERSION
@@ -274,8 +274,8 @@
 	if $(LDCONFIG); then \
 		if ! grep -q "^$(libdir)$$" $(LD_SO_CONF_PATH)/* ; then \
 			$(CC) -o $(objtree)/test $(srctree)/test.c -I $(includedir_SQ) \
-				-L $(libdir_SQ) -ltracefs &> /dev/null; \
-			if ! $(objtree)/test &> /dev/null; then \
+				-L $(libdir_SQ) -ltracefs > /dev/null 2>&1; \
+			if ! $(objtree)/test > /dev/null 2>&1; then \
 				$(call print_install, trace.conf, $(LD_SO_CONF_PATH)) \
 				echo $(libdir_SQ) >> $(LD_SO_CONF_PATH)/trace.conf; \
 				$(LDCONFIG); \
@@ -413,4 +413,3 @@
 	  $(VERSION_FILE) \
 	  $(BUILD_PREFIX))
 
-meson:

=== debian/changelog ===
libtracefs (1.8.3-1) unstable; urgency=medium

  * New upstream version 1.8.3
  * Update Standards-Version to 4.7.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 28 Jan 2026 18:50:11 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,14 @@
 Source: libtracefs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends:
  debhelper-compat (= 13), libcunit1-dev, libtraceevent-dev (>= 1:1.3.0),
  pkgconf, asciidoc, xmlto, source-highlight, flex, bison
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://git.kernel.org/pub/scm/libs/libtrace/libtracefs.git
 Vcs-Browser: https://salsa.debian.org/sudip/libtracefs
 Vcs-Git: https://salsa.debian.org/sudip/libtracefs.git
-Rules-Requires-Root:
 
 Package: libtracefs-dev
 Section: libdevel
